<template>
  <div class="wrapper">
    <div class="container-fuild">
      <div id="headTitle">
        <Logo />
        <h1 id="title" _msttexthash="48503" _msthash="2">{{ i18ntext.lngText('report') }}</h1>
      </div>
      <Header />
      <ol id="topicPath">
        <li style="margin-left: 246px">
          <router-link to="menustock"
            ><a href="dashbaord">
              <font style="vertical-align: inherit">
                <font style="vertical-align: inherit">{{ i18ntext.lngText('report') }}</font>
              </font>
            </a>
          </router-link>
        </li>
      </ol>
    </div>

    <div id="product">
      <div class="search-box-title" id="Bars" style="padding: 0.3rem; padding-left: 2rem">
        <div id="bar" style="width: 90%">
          <router-link to="/report"
            ><a
              class="btn-radius btn btn-sm"
              href="#"
              id="bar-1"
              style="background-color: #29a5a5; border: #22adb763 1px solid"
            >
              <i class="fas fa-cog"> </i> {{ i18ntext.lngText('report') }}
            </a>
          </router-link>
          <router-link to="/salereport">
            <a class="btn-radius btn btn-sm" href="#" id="bar-1">
              <i class="fa fa-cog" aria-hidden="true"></i>
              {{ i18ntext.lngText('sale-report') }}
            </a>
          </router-link>
          <router-link to="/closereport">
            <a class="btn-radius btn btn-sm" href="#" id="bar-1">
              <i class="fa fa-cog" aria-hidden="true"></i>
              {{ i18ntext.lngText('close-report') }}
            </a>
          </router-link>
          <router-link to="/saleitem">
            <a class="btn-radius btn btn-sm" href="#" id="bar-1">
              <i class="fa fa-cog" aria-hidden="true"></i>
              {{ i18ntext.lngText('item-report') }}
            </a>
          </router-link>
          <router-link to="/stockinven">
            <a class="btn-radius btn btn-sm" href="#" id="bar-1">
              <i class="fa fa-cog" aria-hidden="true"></i>
              {{ i18ntext.lngText('iven-report') }}
            </a>
          </router-link>
          <router-link to="/expensesreport">
            <a class="btn-radius btn btn-sm" href="#" id="bar-1">
              <i class="fa fa-cog" aria-hidden="true"></i>
              {{ i18ntext.lngText('exp-report') }}
            </a>
          </router-link>
          <router-link to="/incomereport">
            <a class="btn-radius btn btn-sm" href="#" id="bar-1">
              <i class="fa fa-cog" aria-hidden="true"></i>
              {{ i18ntext.lngText('icm-report') }}
            </a>
          </router-link>
          <router-link to="/incomepen">
            <a class="btn-radius btn btn-sm" href="#" id="bar-1">
              <i class="fa fa-cog" aria-hidden="true"></i>
              {{ i18ntext.lngText('icm-exp') }}
            </a>
          </router-link>
        </div>
      </div>
      <div class="report-container">
        <div class="pos-container card-hieght card-hieght-1">
          <div class="card-report">
            <div class="card-letter">
              <p>{{ i18ntext.lngText('sale-report') }}</p>
            </div>
            <div
              class="box-model"
              style="
                display: grid !important;
                grid-template-columns: repeat(4, 1fr) !important;
              "
            >
              <div class="category-item item-1" style="width: 100% !important">
                <p class="item-title">{{ i18ntext.lngText('service') }}</p>
                <div class="item-title-select">
                  <div class="dropdown d-flex">
                    <button
                      style="width: 100% !important"
                      class="dropdown-toggle string_zen clear_text text select-menu"
                      type="button"
                      id="dropdownMenuButton1"
                      data-bs-toggle="dropdown"
                      aria-expanded="false"
                      size="50"
                    >
                      {{ SelectType }}
                      <i class="fa fa-chevron-down" style="margin-top: 4px"></i>
                    </button>
                    <div
                      class="dropdown-menu each-drop-menu"
                      aria-labelledby="dropdownMenuButton1"
                    >
                      <p>
                        <input autocomplete="off"
                          class="string_zen clear_text text search-pro-field"
                          size="50"
                          type="text"
                        />
                      </p>
                      <ul style="list-style: none" class="scrollable-menu">
                        <li @click="changeType('product')">
                          <div class="menu-item">
                            <p>Coffee & Backery</p>
                          </div>
                        </li>
                        <li @click="changeType('service')">
                          <div class="menu-item">
                            <p>Guest House</p>
                          </div>
                        </li>
                      </ul>
                    </div>
                  </div>
                </div>
              </div>
              <div class="category-item item-2" style="width: 100% !important">
                <p class="item-title">{{ i18ntext.lngText('ch-beg') }}</p>
                <div class="item-title-input">
                  <input autocomplete="off"
                    type="date"
                    style="width: 100%"
                    @change="changeDate()"
                    v-model="form.startDate"
                  />
                </div>
              </div>
              <div class="category-item item-2" style="width: 100% !important">
                <p class="item-title">{{ i18ntext.lngText('ch-end') }}</p>
                <div class="item-title-input">
                  <input autocomplete="off"
                    type="date"
                    style="width: 100%"
                    @change="changeDate()"
                    v-model="form.endDate"
                  />
                </div>
              </div>
            </div>
            <div class="box-model">
              <div class="box-model-1 box-model-item">
                <div class="box-model-title title-1">
                  <p>{{ i18ntext.lngText('total_amount') }}</p>
                </div>
                <div class="box-model-amount">
                  <p class="amount">{{ Number(sale_total).toLocaleString() }}$</p>
                  <p v-if="increment_amount >= 0" class="average-amount">
                    <span><i class="fa fa-arrow-up"></i></span>
                    {{ Number(parseFloat(percentage).toFixed(2)).toLocaleString() }} %
                  </p>
                  <p v-if="increment_amount < 0" class="average-amount-down">
                    <span><i class="fa fa-arrow-down"></i></span>
                    {{
                      Number(Math.abs(parseFloat(percentage).toFixed(2))).toLocaleString()
                    }}
                    %
                  </p>
                </div>
                <div class="box-model-bottom bottom-1">
                  <p class="count-day">Last {{ countday }} days</p>
                </div>
              </div>
              <div class="box-model-2 box-model-item">
                <div class="box-model-title title-2">
                  <p>{{ i18ntext.lngText('amc') }}</p>
                </div>
                <div class="box-model-amount">
                  <p class="amount">{{ Number(inventory).toLocaleString() }}</p>
                  <p v-if="last_inventory == 0" class="average-amount">
                    <span><i class="fa fa-arrow-up"></i></span>
                    0 %
                  </p>

                  <p v-if="last_inventory > 0" class="average-amount">
                    <span><i class="fa fa-arrow-up"></i></span>
                    {{ Number(parseFloat(percentage).toFixed(2)).toLocaleString() }}%
                  </p>
                  <p v-if="last_inventory < 0" class="average-amount-down">
                    <span><i class="fa fa-arrow-down"></i></span>
                    {{
                      Number(
                        Math.abs(parseFloat(percentage).toFixed(2))
                      ).toLocaleString()
                    }}%
                  </p>
                </div>
                <div class="box-model-bottom bottom-2">
                  <p class="count-day">Last {{ countday }} days</p>
                </div>
              </div>
              <div class="box-model-3 box-model-item">
                <div class="box-model-title title-3">
                  <p>{{ i18ntext.lngText('amc-ch') }}</p>
                </div>
                <div class="box-model-amount">
                  <p class="amount">
                    {{ Number(Math.abs(last_inventory)).toLocaleString() }}
                  </p>
                  <p v-if="last_inventory == 0" class="average-amount">
                    <span><i class="fa fa-arrow-up"></i></span>
                    0%
                  </p>

                  <p v-if="last_inventory > 0" class="average-amount">
                    <span><i class="fa fa-arrow-up"></i></span>
                    {{ Number(parseFloat(percentage).toFixed(2)).toLocaleString() }}%
                  </p>
                  <p v-if="last_inventory < 0" class="average-amount-down">
                    <span><i class="fa fa-arrow-down"></i></span>
                    {{
                      Number(
                        Math.abs(parseFloat(percentage).toFixed(2))
                      ).toLocaleString()
                    }}%
                  </p>
                </div>
                <div class="box-model-bottom bottom-3">
                  <p class="count-day">Last {{ countday }} days</p>
                </div>
              </div>

              <div class="box-model-4 box-model-item">
                <div class="box-model-title title-4">
                  <p>{{ i18ntext.lngText('grw-rt') }}</p>
                </div>
                <div class="box-model-amount">
                  <p class="amount">
                    {{ Number(Math.abs(increment_amount)).toLocaleString() }}$
                  </p>
                  <p v-if="increment_amount >= 0" class="average-amount">
                    <span><i class="fa fa-arrow-up"></i></span>
                    {{ Number(parseFloat(percentage).toFixed(2)).toLocaleString() }}%
                  </p>
                  <p v-if="increment_amount < 0" class="average-amount-down">
                    <span><i class="fa fa-arrow-down"></i></span>
                    {{
                      Number(
                        Math.abs(parseFloat(percentage).toFixed(2))
                      ).toLocaleString()
                    }}%
                  </p>
                </div>
                <div class="box-model-bottom bottom-4">
                  <p class="count-day">Last {{ countday }} days</p>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="pos-container card-hieght card-hieght-1">
          <div class="card-report">
            <div class="card-letter">
              <p>{{ i18ntext.lngText('pro-report') }}</p>
            </div>
            <div
              class="box-model"
              style="
                display: grid !important;
                grid-template-columns: repeat(4, 1fr) !important;
              "
            >
              <div class="category-item item-1" style="width: 100% !important">
                <p class="item-title">{{ i18ntext.lngText('product') }}</p>
                <div class="item-title-select">
                  <div class="dropdown d-flex">
                    <button
                      style="width: 100% !important"
                      class="dropdown-toggle string_zen clear_text text select-menu"
                      type="button"
                      id="dropdownMenuButton1"
                      data-bs-toggle="dropdown"
                      aria-expanded="false"
                      size="50"
                    >
                      select
                      <i class="fa fa-chevron-down" style="margin-top: 4px"></i>
                    </button>
                    <div
                      class="dropdown-menu each-drop-menu"
                      aria-labelledby="dropdownMenuButton1"
                    >
                      <p>
                        <input autocomplete="off"
                          @input="searchproduct(txtsearch)"
                          class="string_zen clear_text text search-pro-field"
                          size="50"
                          type="text"
                        />
                      </p>
                      <ul style="list-style: none" class="scrollable-menu">
                        <li>
                          <div class="menu-item">
                            <p>AAAAA</p>
                          </div>
                        </li>
                        <li>
                          <div class="menu-item">
                            <p>AAAAA</p>
                          </div>
                        </li>
                        <li>
                          <div class="menu-item">
                            <p>AAAAA</p>
                          </div>
                        </li>
                      </ul>
                    </div>
                  </div>
                </div>
              </div>
              <div class="category-item item-2" style="width: 100% !important">
                <p class="item-title">{{ i18ntext.lngText('ch-beg') }}</p>
                <div class="item-title-input">
                  <input autocomplete="off"
                    type="date"
                    style="width: 100%"
                    v-model="product_report.startDate"
                  />
                </div>
              </div>
              <div class="category-item item-2" style="width: 100% !important">
                <p class="item-title">{{ i18ntext.lngText('ch-end') }}</p>
                <div class="item-title-input">
                  <input autocomplete="off"
                    type="date"
                    style="width: 100%"
                    v-model="product_report.endDate"
                  />
                </div>
              </div>
            </div>
            <div class="box-model">
              <div class="box-model-5 box-model-item">
                <div class="box-model-title title-5">
                  <p>{{ i18ntext.lngText('pro-sk') }}</p>
                </div>
                <div class="box-model-amount">
                  <p class="amount">
                    {{ Number(result_product.stock_remain).toLocaleString() }}
                  </p>
                  <!-- <p class="average-amount">
                        <span><i class="fa fa-arrow-up"></i></span>


                       0
                       %
                      </p> -->
                </div>
                <div class="box-model-bottom bottom-5">
                  <p class="count-day">In {{ product_report.day }} days</p>
                </div>
              </div>
              <div class="box-model-6 box-model-item">
                <div class="box-model-title title-6">
                  <p>{{ i18ntext.lngText('odr-mon') }}</p>
                </div>
                <div class="box-model-amount">
                  <p class="amount">37</p>
                  <!-- <p class="average-amount">
                        <span><i class="fa fa-arrow-up"></i></span>
                        20%</p> -->
                </div>
                <div class="box-model-bottom bottom-6">
                  <p class="count-day">In {{ product_report.day }} days</p>
                </div>
              </div>
              <div class="box-model-7 box-model-item">
                <div class="box-model-title title-7">
                  <p>{{ i18ntext.lngText('av-con') }}</p>
                </div>
                <div class="box-model-amount">
                  <p class="amount">2,104</p>
                </div>
                <div class="box-model-bottom bottom-7">
                  <p class="count-day">In {{ product_report.day }} days</p>
                </div>
              </div>

              <div class="box-model-8 box-model-item">
                <div class="box-model-title title-8">
                  <p>{{ i18ntext.lngText('grw-rt') }}</p>
                </div>
                <div class="box-model-amount">
                  <p class="amount">8 %</p>

                </div>
                <div class="box-model-bottom bottom-8">
                  <p class="count-day">In {{ product_report.day }} days</p>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="pos-container card-hieght">
          <div class="card-report">
            <div class="card-letter">
              <p>{{ i18ntext.lngText('icm-exp1') }}</p>
            </div>
            <div
              class="box-model"
              style="
                display: grid !important;
                grid-template-columns: repeat(4, 1fr) !important;
              "
            >
              <div class="category-item item-1" style="width: 100% !important">
                <p class="item-title">{{ i18ntext.lngText('product') }}</p>
                <div class="item-title-select">
                  <div class="dropdown d-flex">
                    <button
                      style="width: 100% !important"
                      class="dropdown-toggle string_zen clear_text text select-menu"
                      type="button"
                      id="dropdownMenuButton1"
                      data-bs-toggle="dropdown"
                      aria-expanded="false"
                      size="50"
                    >
                      Select
                      <i class="fa fa-chevron-down" style="margin-top: 4px"></i>
                    </button>
                    <div
                      class="dropdown-menu each-drop-menu"
                      aria-labelledby="dropdownMenuButton1"
                    >
                      <p>
                        <input autocomplete="off"
                          class="string_zen clear_text text search-pro-field"
                          size="50"
                          type="text"
                        />
                      </p>
                      <ul style="list-style: none" class="scrollable-menu">
                        <li>
                          <div class="menu-item">
                            <p>AAAAA</p>
                          </div>
                        </li>
                        <li>
                          <div class="menu-item">
                            <p>AAAAA</p>
                          </div>
                        </li>
                        <li>
                          <div class="menu-item">
                            <p>AAAAA</p>
                          </div>
                        </li>
                      </ul>
                    </div>
                  </div>
                </div>
              </div>
              <div class="category-item item-2" style="width: 100% !important">
                <p class="item-title">{{ i18ntext.lngText('ch-beg') }}</p>
                <div class="item-title-input">
                  <input autocomplete="off" type="date" style="width: 100%" />
                </div>
              </div>
              <div class="category-item item-2" style="width: 100% !important">
                <p class="item-title">{{ i18ntext.lngText('ch-end') }}</p>
                <div class="item-title-input">
                  <input autocomplete="off" type="date" style="width: 100%" />
                </div>
              </div>
            </div>
            <div class="box-model">
              <div class="box-model-9 box-model-item">
                <div class="box-model-title title-9">
                  <p>{{ i18ntext.lngText('total_amount') }}</p>
                </div>
                <div class="box-model-amount">
                  <p class="amount">2,104</p>
                  <p class="average-amount">
                    <span><i class="fa fa-arrow-up"></i></span>
                    20%
                  </p>
                </div>
                <div class="box-model-bottom bottom-9">
                  <p class="count-day">In 30 days</p>
                </div>
              </div>
              <div class="box-model-10 box-model-item">
                <div class="box-model-title title-10">
                  <p>{{ i18ntext.lngText('odr-mon') }}</p>
                </div>
                <div class="box-model-amount">
                  <p class="amount">37</p>
                  <p class="average-amount">
                    <span><i class="fa fa-arrow-up"></i></span>
                    20%
                  </p>
                </div>
                <div class="box-model-bottom bottom-10">
                  <p class="count-day">In 30 days</p>
                </div>
              </div>
              <div class="box-model-11 box-model-item">
                <div class="box-model-title title-11">
                  <p>{{ i18ntext.lngText('av-con') }}</p>
                </div>
                <div class="box-model-amount">
                  <p class="amount">2,104</p>
                  <p class="average-amount">
                    <span><i class="fa fa-arrow-up"></i></span>
                    20%
                  </p>
                </div>
                <div class="box-model-bottom bottom-11">
                  <p class="count-day">In 30 days</p>
                </div>
              </div>

              <div class="box-model-12 box-model-item">
                <div class="box-model-title title-12">
                  <p>{{ i18ntext.lngText('grw-rt') }}</p>
                </div>
                <div class="box-model-amount">
                  <p class="amount">8 %</p>
                  <p class="average-amount">
                    <span><i class="fa fa-arrow-up"></i></span>
                    20%
                  </p>
                </div>
                <div class="box-model-bottom bottom-12">
                  <p class="count-day">In 30 days</p>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>

  <Footer />
  <UserInfo />
</template>

<script>
import axios from "axios";
import { useCurrentTime } from "../../componentJS/date";
import pagination from "laravel-vue-pagination";
import print from "vue3-print-nb";
import Logo from "../logo.vue";
import Footer from "../footer.vue";
import moment from "moment";
import Auth from "../../auth/Auth";
import Header from "../Header.vue";
import UserInfo from "../UserInfo.vue"
import i18n from "../../i18n/i18n";
export default {
  components: {
    Header,
    Logo,
    pagination,
    Footer,
    UserInfo,
  },

  directives: {
    print,
  },

  setup() {
    const { currentTime } = useCurrentTime();
    return { currentTime };
  },

  data() {
    return {
      i18ntext: i18n,
      sale_total: 0,
      increment_amount: 0,
      last_inventory: 0,
      countday: 0,
      percentage: 0,
      startDate: "",
      thirdDate: "",
      endDate: "",
      inventory: 0,
      exchange_rate: 0,
      form: {
        created_by: Auth.user.id,
        startDate: "",
        endDate: "",
        thirdDate: "",
        type: "saleproduct",
      },
      oneDay: 24 * 60 * 60 * 1000,

      product_report: {
        created_by: Auth.user.id,
        startDate: "",
        endDate: "",
        thirdDate: "",
        day: 0,
      },

      result_product: {
        stock_remain: 0,
        percentage: 0,
      },
      SelectType: "Coffee & Backery",
    };
  },

  mounted() {
    if (Auth.check()) {
        if(!Auth.checkPermission('REPORT_ALL')){
            this.$router.push('/dashboard');
        }
    }
    this.form.endDate = moment(new Date()).format("YYYY-MM-DD");
    const myDate = new Date();
    this.form.startDate = moment(myDate.setMonth(myDate.getMonth() - 1)).format(
      "YYYY-MM-DD"
    );

    this.form.thirdDate = moment(myDate.setMonth(myDate.getMonth() - 1)).format(
      "YYYY-MM-DD"
    );

    const firstDate = new Date(this.form.startDate);
    const secondDate = new Date(this.form.endDate);
    this.countday = Math.round(Math.abs((firstDate - secondDate) / this.oneDay));

    this.product_report.endDate = moment(new Date()).format("YYYY-MM-DD");
    const date = new Date();
    this.product_report.startDate = moment(date.setMonth(date.getMonth() - 1)).format(
      "YYYY-MM-DD"
    );
    this.product_report.thirdDate = moment(date.setMonth(date.getMonth() - 1)).format(
      "YYYY-MM-DD"
    );

    let first = new Date(this.product_report.startDate);
    let second = new Date(this.product_report.endDate);

    this.product_report.day = Math.round(Math.abs((first - second) / this.oneDay));

    this.getProductSale();
    this.ProductReport();
  },

  methods: {
    async getProductSale() {
      await axios.post("api/v1/salereport/getsaleproduct", this.form).then((res) => {
        this.exchange_rate = res.data.data[0].exchane_rate;
        this.sale_total = res.data.total / this.exchange_rate;
        this.percentage = res.data.percentage;
        this.inventory = res.data.item_this_month;
        this.increment_amount = res.data.increment_amount / this.exchange_rate;
        this.last_inventory = res.data.increment_inven;

      });
    },

    changeDate() {
      let firstDate = new Date(this.form.startDate);
      let secondDate = new Date(this.form.endDate);
      this.countday = Math.round(Math.abs((firstDate - secondDate) / this.oneDay));

      this.getProductSale();
    },
    async ProductReport() {
      await axios
        .post("api/v1/product/productreport", this.product_report)
        .then((res) => {
          this.result_product.stock_remain = res.data.remain;
          this.result_product.percentage = res.data.percentage;
        });
    },
    changeType(text) {
      if (text === "product") {
        this.SelectType = "Coffee & Backery";
        this.form.type = "saleproduct";
        this.getProductSale();
      }
      if (text === "service") {
        this.SelectType = "Guest House";
        this.form.type = "saleservice";
        this.getProductSale();
      }
    },
  },
};
</script>
